<template>
    <div>
        <el-card class="el-card">
            <el-form :inline="true" :model="filterQuery"
                     class="query-form" size="mini">
                <el-row>
                    <el-form-item class="query-form-item">
                        <el-input
                            v-model="filterQuery.billNo"
                            placeholder="单据号"
                            clearable
                        ></el-input>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <el-input
                            v-model="filterQuery.corpName"
                            placeholder="往来单位"
                            clearable
                        ></el-input>
                    </el-form-item>
                    <el-form-item class="query-form-item">

                        <el-select v-model="filterQuery.billAction" placeholder="单据类型" clearable="true">
                            <el-option
                                v-for="item in originTypes"
                                :key="item.name"
                                :label="item.name"
                                :value="item.action">
                                <span style="float: left;font-size: 13px">{{ item.name }}</span>
                                <span style="float: right; color: #8492a6; font-size: 13px;margin-left: 10px">{{
                                        item.thirdSysName
                                    }}</span>
                            </el-option>

                        </el-select>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <span style="color: #000; margin-left: 10px; margin-right: 6px">单据日期:</span>
                        <el-date-picker
                            :picker-options="pickerOptions"
                            v-model="actDateRange"
                            type="daterange"
                            format="yyyy 年 MM 月 dd 日"
                            value-format="yyyy-MM-dd"
                            range-separator="至"
                            start-placeholder="开始日期"
                            end-placeholder="结束日期"
                        >
                        </el-date-picker>
                    </el-form-item>
                    <el-form-item>
                        <el-button-group style="display:flex;">
                            <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                            <el-button type="primary" icon="search" @click="onSubmitFind">查询</el-button>
                            <el-button type="primary" icon="search" @click="newDistributionForm()" :loading="loading">
                                新增单据
                            </el-button>


                        </el-button-group>

                    </el-form-item>
                </el-row>
            </el-form>
            <el-table v-loading="loading" :data="list" style="width: 100%" highlight-current-row="true"
                      @current-change="handleDetail">
                <el-table-column label="序号" type="index" width="60"></el-table-column>
                <el-table-column label="单据类型" prop="billTypeName"></el-table-column>
                <el-table-column label="单据号" prop="billNo"></el-table-column>
                <el-table-column label="领用分库" prop="invWarehouseName"></el-table-column>
                <el-table-column label="往来信息" prop="fromSubInvName"
                                 show-overflow-tooltip="true"></el-table-column>
                <el-table-column label="单据日期" prop="billdate"></el-table-column>
                <el-table-column label="操作" fixed="right">
                    <template slot-scope="scope">
                        <el-button
                            type="text"
                            size="small"
                            @click.native="newDistributionForm(scope.$index, scope.row)"
                        >编辑
                        </el-button
                        >
                        <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)"
                        >删除
                        </el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination
                :page-size="filterQuery.limit"
                @current-change="handleCurrentChange"
                layout="prev, pager, next"
                :total="total"
                :current-page="filterQuery.page"
            ></el-pagination>
        </el-card>
        <el-card class="el-card">
            <el-table v-loading="loading" :data="detailList" style="width: 100%">
                <el-table-column label="序号" type="index" width="120"></el-table-column>
                <el-table-column label="产品编码" prop="productId"></el-table-column>
                <el-table-column label="产品通用名" prop="productName" show-overflow-tooltip="true"></el-table-column>
                <el-table-column label="规格型号" prop="spec" show-overflow-tooltip="true"></el-table-column>
                <el-table-column label="批次号" prop="batchNo"></el-table-column>
                <el-table-column label="生产日期" prop="productDate"></el-table-column>
                <el-table-column label="失效日期" prop="expireDate"></el-table-column>
                <el-table-column label="单据数量" prop="count"></el-table-column>
            </el-table>
        </el-card>

        <el-dialog
            :title="formMap[formName]"
            :visible.sync="newSpDistributionVisible"
            width="80%"
            v-if="newSpDistributionVisible"
            @close='closeDialog'
            :close-on-click-modal="false"
            :close-on-press-escape="false"
        >
            <thrOrderNew
                :closeDialog="closeDialog"
                :idQuery="idQuery"
                :closeConfirmFunction="closeConfirmFunction"
                :editType="formName"
            ></thrOrderNew>
        </el-dialog>
    </div>
</template>
<script>
import {
    delThrOrders, delAll, downloadAll
} from "../../api/thrsys/thrOrder";
import {getLocalJoinBusType} from "../../api/basic/busLocalType";
import {getOriginBusType} from "../../api/basic/busOriginType";

import {getBasicThirdSys, filterDetailByKey} from "../../api/basic/basicThirdSys";
import {selectIp} from "../../api/param/systemParamConfig";
import {
    getCloudErp,
} from "../../api/inout/erpOrder";
import thrOrderNew from "./thrOrderNew";
import {getReceiveOrder} from "@/api/inout/receiveOrder";

export default {
    data() {
        return {
            filterQuery: {
                billAction: null,
                billNo: "",
                originType: null,
                thirdSysFk: "",
                page: 1,
                limit: 10,
                corpName: null,
                type: 1,
                editStatus: 1,
                thirdPartyDate: 2,
            },
            formName: null,
            formMap: {
                add: "新增领用单据",
                update: "编辑领用单据",
            },

            idQuery: {},
            total: 0,
            thirdSys: [],
            thirdSysDetail: null,
            busTypes: [],
            originTypes: [],
            list: [],
            detailList: [],
            uploadFileUrl: null,
            fileList: [],
            uploadData: {
                thirdSys: "thirdId",
            },
            closeConfirm: false,
            loading: false,
            actDateRange: [],
            newSpDistributionVisible: false,
            pickerOptions: {
                shortcuts: [
                    {
                        text: "最近一周",
                        onClick(picker) {
                            const end = new Date();
                            const start = new Date();
                            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
                            picker.$emit("pick", [start, end]);
                        },
                    },
                    {
                        text: "最近一个月",
                        onClick(picker) {
                            const end = new Date();
                            const start = new Date();
                            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
                            picker.$emit("pick", [start, end]);
                        },
                    },
                    {
                        text: "最近三个月",
                        onClick(picker) {
                            const end = new Date();
                            const start = new Date();
                            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
                            picker.$emit("pick", [start, end]);
                        },
                    },
                ],
            },
        };
    },

    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                billNo: "",
                thirdSysFk: "",
                billFlag: null,
                billAction: null,
                startDate: null,
                endDate: null,
                page: 1,
                limit: 10,
                corpName: null,
                type: 1,
                editStatus: 1,
                thirdPartyDate: 2,
            };
            this.actDateRange = [];
            this.getList();
        },

        onSubmitFind() {
            this.filterQuery.page = 1;
            this.getList();
        },

        getList() {
            if (this.filterQuery.thirdSysFk == null) {
                this.$message.warning("请先选择第三方系统！")
                return;
            }
            if (this.actDateRange != null) {
                this.filterQuery.startDate = this.actDateRange[0];
                this.filterQuery.endDate = this.actDateRange[1];
            } else {
                this.filterQuery.startDate = null;
                this.filterQuery.endDate = null;
            }
            this.loading = true;
            getReceiveOrder(this.filterQuery)
                .then((response) => {
                    if (response.code == 20000) {
                        this.list = response.data.list || [];
                        this.total = response.data.total || 0;
                    } else {
                        this.$message.error(response.message);
                    }
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        handleDetail(row) {
            this.detailList = row.subErpOrders;
        },
        deleteDialog(row) {
            this.$confirm("此操作将永久删除该单据, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    let dQuery = {
                        id: row.id,
                    };
                    delThrOrders(dQuery)
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                                this.getList();
                            } else {
                                this.$message.error(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        });

                })
                .catch(() => {
                });
        },
        clearAll() {
            this.$confirm("此操作将清空所有单据, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    delAll()
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                                this.getList();
                            } else {
                                this.$message.success(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        });

                })
                .catch(() => {
                });
        },
        getBasicThirdSys() {
            let query = {
                enabled: true,
            };
            getBasicThirdSys(query)
                .then((response) => {
                    this.thirdSys = response.data.list || [];
                    this.filterQuery.thirdSysFk = this.thirdSys[0].thirdId;
                    this.uploadData.thirdSys = this.filterQuery.thirdSysFk;
                    this.selectSysParam();
                    this.getThirdSysDetail();
                    this.getBusType();
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });
        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },
        handleChange(response, files, fileList) {
            console.log(response);
            if (response.code != 20000) {
                this.$message.error(response.message);
            } else {
                console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
                this.$message.success("文件上传成功,请稍后刷新查看！");
            }
        },
        selectSysParam() {
            let query = {
                key: "thirdIpUrl",
                thirdSysFk: this.filterQuery.thirdSysFk
            };
            selectIp(query).then((response) => {
                if (response.code == 20000) {
                    this.uploadFileUrl = response.data.thridUrl + "/udiwms/erp/pi/upload";
                }
            });
        },
        thirdSysChange() {
            this.uploadData.thirdSys = this.filterQuery.thirdSysFk;
            this.getThirdSysDetail();
        },
        getThirdSysDetail() {
            let query = {
                thirdSysFk: this.filterQuery.thirdSysFk,
                key: "orderQueryUrl",
            };
            filterDetailByKey(query)
                .then((response) => {
                    this.thirdSysDetail = response.data;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });

        },
        downloadDatas() {
            let query = {
                billAction: this.filterQuery.billAction
            };
            downloadAll(query).then((response) => {
                if (response.code == 20000) {
                    this.$message.success(response.data);
                } else {
                    this.$message.error(response.message);
                }
            });

        },
        getActionName(action) {
            for (let i = 0; i < this.busTypes.length; i++) {
                if (this.busTypes[i].action === action) {
                    return this.busTypes[i].name;
                }
            }
        },
        closeConfirmFunction(type) {
            if (this.$isNotBlank(type) && type) {
                this.closeConfirm = type;
            }
        },
        getlocalName(action) {
            for (let i = 0; i < this.busTypes.length; i++) {
                if (this.busTypes[i].action === action) {
                    return this.busTypes[i].localName;
                }
            }
        },
        getBusType() {
            let query = {
                enabled: true,
                corpType: 1,
            };
            getLocalJoinBusType(query)
                .then((response) => {
                    this.busTypes = response.data.list || [];
                    // this.getList();
                })
                .catch(() => {
                });
            getOriginBusType(query)
                .then((response) => {
                    this.originTypes = response.data.list || [];
                    // this.filterQuery.originType = this.originTypes[0].action;
                    // this.getList();
                })
                .catch(() => {
                });


        },

        closeDialog() {
            this.newSpDistributionVisible = false;
            this.getList();
            this.detailList = [];
        },


        newDistributionForm(index, row) {
            this.idQuery.id = '';
            if (this.$isNotBlank(row) && this.$isNotBlank(row.id)) {
                this.idQuery.id = row.id;
                this.idQuery.formData = row;
                this.formName = "update";
            } else
                this.formName = "add";
            this.newSpDistributionVisible = true;
        },

    },
    components: {
        thrOrderNew,
    },
    mounted() {
    },
    created() {
        this.getBasicThirdSys();
        let end = new Date();
        let start = new Date();
        start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
        this.actDateRange = [start, end];
        this.getList();
    },
};
</script>
<style scoped>
.itemTag {
    float: left;
    text-align: left;
    margin-top: 10px;
    width: 25%;
}

.text {
    font-size: 13px;
    font-family: "Microsoft YaHei";
}

.query-form-item {
    display: block !important;
    margin-right: 10px;
    margin-bottom: 5px;
}

.el-row {
    display: flex;
    flex-wrap: wrap;
}

.el-col {
    border-radius: 4px;
    flex-wrap: wrap;
}
</style>

